# vim:noexpandtab:autoindent:tabstop=8:shiftwidth=8:filetype=make:nocindent:


# push dir ... 
# If anything in this makefile needs to use the directory name, use the 
# $(d) variable. It will be properly set and reset, even in submake files.
# Any variable that uses the $(d) variable must be an IMMEDIATE variable, 
# ie. it must be "variable :=  $(d)/file", note the ":=".
#### only works for make version >= 3.80
####dir := $(dir $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST)))
sp 				:= $(sp).x
dirstack_$(sp)	:= $(d)
d				:= $(dir)

$(d)/SmbiosXml_xerces.d: $(d)/StdSmbiosXml.h
$(d)/StdSmbiosXml.h: doc/smbios23.xml build/scripts/makeXmlHeader.py $(d)/module.mk
	build/scripts/makeXmlHeader.py doc/smbios23.xml $@

CLEAN_LIST += $(d)/StdSmbiosXml.h

libname := smbiosxml
$(libname)_MAJOR := 1
$(libname)_MINOR := 0
$(libname)_LIBS := $(d)/../common/XmlUtils.o
$(libname)_LDFLAGS := -lxerces-c 

ifeq 'libxml2' '$(XMLLIB)' 
$(libname)_LIBS += $(d)/SmbiosXml_libxml2.o 
else
$(libname)_LIBS += $(d)/SmbiosXml_xerces.o 
endif

#special dependencies because we have a generated .h file here
$($(libname)_DYN_FILENAMES):  libraries/smbiosxml/StdSmbiosXml.h 
$($(libname)_STATIC):  	      libraries/smbiosxml/StdSmbiosXml.h 
$($(libname)_STATIC_DEBUG):   libraries/smbiosxml/StdSmbiosXml.h 

# Pop dir stack back to what it was
d		:= $(dirstack_$(sp))
sp		:= $(basename $(sp))
